//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4AAE80DF0296.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4AAE80DF0296.cm

//## begin module%4AAE80DF0296.cp preserve=no
//## end module%4AAE80DF0296.cp

//## Module: PlotPane%4AAE80DF0296; Package specification
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSPlot/Plot/PlotPane.h

#ifndef PLOTPANE_H
#define PLOTPANE_H 1

//## begin module%4AAE80DF0296.additionalIncludes preserve=no
//## end module%4AAE80DF0296.additionalIncludes

//## begin module%4AAE80DF0296.includes preserve=yes
//## end module%4AAE80DF0296.includes


struct PlotGroup;

//## begin module%4AAE80DF0296.declarations preserve=no
//## end module%4AAE80DF0296.declarations

//## begin module%4AAE80DF0296.additionalDeclarations preserve=yes
#include <xsTypes.h>
#include <XSPlot/Plot/PlotTypes.h>
//## end module%4AAE80DF0296.additionalDeclarations


//## begin PlotPane%4AAE870602B3.preface preserve=yes
//## end PlotPane%4AAE870602B3.preface

//## Class: PlotPane%4AAE870602B3
//## Category: XSPlot::Plot%3D625E6A0065
//## Subsystem: XSPlot::Plot%3D625E94026B
//## Persistence: Transient
//## Cardinality/Multiplicity: n



class PlotPane 
{
  //## begin PlotPane%4AAE870602B3.initialDeclarations preserve=yes
  //## end PlotPane%4AAE870602B3.initialDeclarations

  public:
    //## Constructors (specified)
      //## Operation: PlotPane%4AE8BCFC0214
      PlotPane (const PlotRange& ranges, const StandardLabels& labels, const std::vector<PlotGroup*>& plotGroups);

    //## Destructor (generated)
      ~PlotPane();


    //## Other Operations (specified)
      //## Operation: lineIDs%4B5F5B700289
      //	This non-const get-by-reference function is to allow the
      //	LineIDContainer to be filled without having to do a
      //	copy, as would be necessary in a standard set function.
      //	This container can be quite large.
      LineIDContainer& lineIDs ();

    //## Get and Set Operations for Class Attributes (generated)

      //## Attribute: ranges%4AE8BC0800F0
      const PlotRange& ranges () const;

      //## Attribute: labels%4AE8BC8302C6
      const StandardLabels& labels () const;

      //## Attribute: panePosition%4B0B0A5802A4
      //	This contains the positions of the lower-left and
      //	upper-right corners in generic coordinates, where the
      //	largest single pane may stretch from (0,0) to (1,1).
      //	Note that titles and axis labels and numbering are
      //	intended to reside outside of these coordinates.
      const PlotRectangle& panePosition () const;
      void panePosition (const PlotRectangle& value);

      //## Attribute: stackIndex%4B19763202C2
      //	A 0-based index indicating the vertical stack in which
      //	this pane resides.  It ought to be set no later than
      //	when panePosition is set.
      size_t stackIndex () const;
      void stackIndex (size_t value);

      //## Attribute: isContour%4B50DAF00031
      //	True if this is a 2-D contour plot.
      bool isContour () const;

      //## Attribute: lineIDs%4B5F5A570391
      //	Optional line ID strings.  PlotDirector will attempt to
      //	fill this if setplot ID is turned on AND it is
      //	applicable to the PlotCommand AND the X-axis mode IS NOT
      //	channels.
      const LineIDContainer& lineIDs () const;

    //## Get and Set Operations for Associations (generated)

      //## Association: XSPlot::Plot::<unnamed>%4AE8B97B004A
      //## Role: PlotPane::plotGroups%4AE8B97B0351
      //	PlotPane does not own these.  The are "loaned" to it by
      //	PlotDirector.
      const std::vector<PlotGroup*>& plotGroups () const;

    // Additional Public Declarations
      //## begin PlotPane%4AAE870602B3.public preserve=yes
      //## end PlotPane%4AAE870602B3.public

  protected:
    // Additional Protected Declarations
      //## begin PlotPane%4AAE870602B3.protected preserve=yes
      //## end PlotPane%4AAE870602B3.protected

  private:
    //## Constructors (generated)
      PlotPane(const PlotPane &right);

    //## Assignment Operation (generated)
      PlotPane & operator=(const PlotPane &right);

    // Additional Private Declarations
      //## begin PlotPane%4AAE870602B3.private preserve=yes
      //## end PlotPane%4AAE870602B3.private

  private: //## implementation
    // Data Members for Class Attributes

      //## begin PlotPane::ranges%4AE8BC0800F0.attr preserve=no  public: PlotRange {UC} 
      const PlotRange m_ranges;
      //## end PlotPane::ranges%4AE8BC0800F0.attr

      //## begin PlotPane::labels%4AE8BC8302C6.attr preserve=no  public: StandardLabels {UC} 
      const StandardLabels m_labels;
      //## end PlotPane::labels%4AE8BC8302C6.attr

      //## begin PlotPane::panePosition%4B0B0A5802A4.attr preserve=no  public: PlotRectangle {U} 
      PlotRectangle m_panePosition;
      //## end PlotPane::panePosition%4B0B0A5802A4.attr

      //## begin PlotPane::stackIndex%4B19763202C2.attr preserve=no  public: size_t {U} 
      size_t m_stackIndex;
      //## end PlotPane::stackIndex%4B19763202C2.attr

      //## begin PlotPane::isContour%4B50DAF00031.attr preserve=no  public: bool {UC} 
      const bool m_isContour;
      //## end PlotPane::isContour%4B50DAF00031.attr

      //## begin PlotPane::lineIDs%4B5F5A570391.attr preserve=no  public: LineIDContainer {U} 
      LineIDContainer m_lineIDs;
      //## end PlotPane::lineIDs%4B5F5A570391.attr

    // Data Members for Associations

      //## Association: XSPlot::Plot::<unnamed>%4AE8B97B004A
      //## begin PlotPane::plotGroups%4AE8B97B0351.role preserve=no  public: PlotGroup {1..n -> 1RFHgNC}
      const std::vector<PlotGroup*> m_plotGroups;
      //## end PlotPane::plotGroups%4AE8B97B0351.role

    // Additional Implementation Declarations
      //## begin PlotPane%4AAE870602B3.implementation preserve=yes
      //## end PlotPane%4AAE870602B3.implementation

};

//## begin PlotPane%4AAE870602B3.postscript preserve=yes
//## end PlotPane%4AAE870602B3.postscript

// Class PlotPane 


//## Other Operations (inline)
inline LineIDContainer& PlotPane::lineIDs ()
{
  //## begin PlotPane::lineIDs%4B5F5B700289.body preserve=yes
   return m_lineIDs;
  //## end PlotPane::lineIDs%4B5F5B700289.body
}

//## Get and Set Operations for Class Attributes (inline)

inline const PlotRange& PlotPane::ranges () const
{
  //## begin PlotPane::ranges%4AE8BC0800F0.get preserve=no
  return m_ranges;
  //## end PlotPane::ranges%4AE8BC0800F0.get
}

inline const StandardLabels& PlotPane::labels () const
{
  //## begin PlotPane::labels%4AE8BC8302C6.get preserve=no
  return m_labels;
  //## end PlotPane::labels%4AE8BC8302C6.get
}

inline const PlotRectangle& PlotPane::panePosition () const
{
  //## begin PlotPane::panePosition%4B0B0A5802A4.get preserve=no
  return m_panePosition;
  //## end PlotPane::panePosition%4B0B0A5802A4.get
}

inline void PlotPane::panePosition (const PlotRectangle& value)
{
  //## begin PlotPane::panePosition%4B0B0A5802A4.set preserve=no
  m_panePosition = value;
  //## end PlotPane::panePosition%4B0B0A5802A4.set
}

inline size_t PlotPane::stackIndex () const
{
  //## begin PlotPane::stackIndex%4B19763202C2.get preserve=no
  return m_stackIndex;
  //## end PlotPane::stackIndex%4B19763202C2.get
}

inline void PlotPane::stackIndex (size_t value)
{
  //## begin PlotPane::stackIndex%4B19763202C2.set preserve=no
  m_stackIndex = value;
  //## end PlotPane::stackIndex%4B19763202C2.set
}

inline bool PlotPane::isContour () const
{
  //## begin PlotPane::isContour%4B50DAF00031.get preserve=no
  return m_isContour;
  //## end PlotPane::isContour%4B50DAF00031.get
}

inline const LineIDContainer& PlotPane::lineIDs () const
{
  //## begin PlotPane::lineIDs%4B5F5A570391.get preserve=no
  return m_lineIDs;
  //## end PlotPane::lineIDs%4B5F5A570391.get
}

//## Get and Set Operations for Associations (inline)

inline const std::vector<PlotGroup*>& PlotPane::plotGroups () const
{
  //## begin PlotPane::plotGroups%4AE8B97B0351.get preserve=no
  return m_plotGroups;
  //## end PlotPane::plotGroups%4AE8B97B0351.get
}

//## begin module%4AAE80DF0296.epilog preserve=yes
//## end module%4AAE80DF0296.epilog


#endif
